import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.TreeMap;
import java.lang.Integer;

public class BagOfWords {
	
	private String bowFile;
	protected Thesaurus thes;
	private int bow[][];
	private int docCount;
	private int totalWordCount;// sum of unique terms in the doc vectors
	private int uniqueWordCount;
	private HashMap<String, Integer> terms;
	private TreeMap<Integer, String> termID;
	private Map<Integer, int[]> docVecLocator;
	
	
	public BagOfWords()
	{
		//
	}
	
	public BagOfWords(String fileName)
	{
		this.build(fileName);
	}
	
	public BagOfWords(String fileName, String thesFile)
	{
		thes = new Thesaurus();
		thes.buildThesaurus(thesFile);
		this.build(fileName);
	}
	
	public void build(String fileName)
	{
		bowFile = fileName;
		
	
		// read in the  text
		docCount = 0; // count the number of documents

		String[] termArray = null; // isolate all words

		terms = new HashMap<String, Integer>();
		termID = new TreeMap<Integer, String>();
		int uniqueTermCount = 0;

		int oldSize = 0;
		try {

			Tic readTime = new Tic();
			int len = (int)(new File(fileName).length());
			FileInputStream fis = new FileInputStream(fileName);

			byte bytArr[] = new byte[len];
			fis.read(bytArr);
			fis.close();
			readTime.toc("Time to read: ");
			ArrayList<Integer> newLines = new ArrayList<Integer>();
			//System.out.println("Counting Docs: " + System.currentTimeMillis());
			for (int i = 0; i < len; i++) {
				if (bytArr[i] == '\n') {
					newLines.add(i);
					docCount++;
				}
			}
			if ( bytArr[len-1] != '\n') 
			{
				docCount++; // if the last line does not have a new line
				newLines.add(len);
			}

			HashMap<Integer, int[]> docVecLocator1 = new HashMap<Integer, int[]>(docCount);
			// assume 7 char per word and estimate an initial size
			int initialSize = (int) (Math.floor(newLines.get(0)/4) * docCount);
			System.out.println("initial size: " + initialSize);
			bow = new int[initialSize][3];

			// go through the bytArr and take each line and process that to minimize memory

			readTime.toc("Time to count Docs: ");

			int lastNL = 0;
//			for(int i = 0; i < docCount; i++)
			Iterator<Integer> nlIt = newLines.iterator();
			int dc = 0, tc = 0;
			//while()
			while(nlIt.hasNext())
			{
				dc++;
				//int a = (Integer)nlIt.;
				int a = (Integer)nlIt.next();
				String strLine = new String(bytArr, lastNL, a - lastNL);


//				System.out.println(" strLine: " + strLine.length()
//				+ " a:" + a
//				+ " lastNL: " + lastNL
//				+ " realSize: " + (a - lastNL));

				lastNL = a;

				if (thes != null)
					strLine = thes.applyToString(strLine);
				else strLine = strLine.toUpperCase();
				strLine = strLine.replaceAll("[^A-Za-z]", " ");
				strLine = strLine.trim().replaceAll("\\b\\s{2,}\\b", " ");

				// isolate all words and add them to the term id hash
				termArray = strLine.split(" ");
//				for(int kk = 0; kk < termArray.length; kk++) System.out.print(termArray[kk] + " ");
//				System.out.println();

//				System.out.println("termArray: " + termArray.length
//				+ " strLine: " + strLine.length());

				//TreeMap<Integer,Integer> docVec = new TreeMap<Integer,Integer>();
				Map<Integer,Integer> docVec1 = new HashMap<Integer,Integer>();

				int i = 0;
				Object currentWordID = null;
				int dvIndex;
				while ( i < termArray.length)
				{
					//System.out.println(i + ":" + termArray[i] + ":" + uniqueTermCount);
					// the next if statement might or might not help.  Try on big file
					//if (termTree.contains(termArray[i])) 
					currentWordID = terms.get(termArray[i]);
					if ((currentWordID) == null){
						terms.put(termArray[i], ++uniqueTermCount);// the term index starts at 1
						termID.put(uniqueTermCount, termArray[i]);
						docVec1.put(uniqueTermCount, 1);
						//System.out.println(termArray[i] + ":" + uniqueTermCount);
						i++;
					}
					else {
						//get the current count and add 1
						Object freq = docVec1.get((Integer)currentWordID);
						if(freq == null)
							docVec1.put((Integer)currentWordID, 1);
						else 
							docVec1.put((Integer)currentWordID, ((Integer)freq + 1));

						i++;
					}

				}
				Map<Integer, Integer> docVec = new TreeMap<Integer, Integer>(docVec1);

				int currentTerm = 0;
				int tmparr[] = {oldSize, docVec.size()};
				docVecLocator1.put(dc, tmparr);
				Iterator<Integer> itr2 = docVec.keySet().iterator();
				while (itr2.hasNext())
				{
					
					currentTerm = (Integer)itr2.next();
					bow[oldSize][0] = dc;
					bow[oldSize][1] = currentTerm;
					bow[oldSize++][2] = (Integer)docVec.get(currentTerm);
//					System.out.println((oldSize-1)
//							+ " " + bow[oldSize-1][0]
//							+ " " + bow[oldSize-1][1]
//							+ " " + bow[oldSize-1][2]);
				}

				if (initialSize - oldSize < 1000)
				{
					int reSize = initialSize + (docCount - dc) * 1000;
					int[][] tbow = new int[reSize - 1][3];
					System.arraycopy(bow, 0, tbow, 0, oldSize);
					bow = tbow.clone();
					initialSize = reSize;
					//System.out.println("resized at: " + (oldSize - 1));
//					System.out.println(" : " + bow[oldSize-1][0]
//					        + " : " + bow[oldSize-1][1]
//					        +" : " + bow[oldSize-1][2]);                      
					                                     
				}

				if (dc%1000 == 0){
					System.out.print(dc + "/" + docCount
							+ " - UniqueTerms(total/new) " + uniqueTermCount
							+ "/" + (uniqueTermCount - tc));
					readTime.lap(" Process Time So far ");
					tc = uniqueTermCount;
				}
				//if(!nlIt.hasNext()) break;
			}
			docVecLocator = new TreeMap<Integer, int[]>(docVecLocator1);

		}
		catch (FileNotFoundException e) {
			System.err.print("ERROR: Failed to open file " + fileName);
		}
		catch (IOException e) { 
			System.err.print("ERROR: Failed to open file " + fileName);
		}

		// remove extra zeros from bow
		//System.out.println("line 289:" + oldSize);
		{
			int[][] tbow = new int[oldSize][3];
			System.arraycopy(bow, 0, tbow, 0, oldSize);
			bow = tbow.clone();
		}
		totalWordCount = oldSize;
		uniqueWordCount = terms.size();
		
	}
	
	public int[][] getBow()
	{
		int tbow[][] = bow.clone();
		return tbow;
	}
	
	public int termCount()
	{
		return uniqueWordCount;
	}
	
	public int docCount()
	{
		return docCount;
	}
	
	public TreeMap<Integer, String> getTermID()
	{
		return termID;
	}
	
	public String getTerm(int i)
	{
		String term = termID.get(i);
		if(term == null)
		{
			System.err.println("No term with ID " + i);
			System.exit(-1);
		}
		return term;//termID.get(i);
		
	}
	
	public String getTermLine()
	{
		StringBuilder output = new StringBuilder();
		Object[] keys = termID.keySet().toArray();
		for (int i = 0; i < keys.length; i++)
			output.append(String.format("%s=%s ",keys[i], termID.get(keys[i])));
		
		output.append("\n");
		return output.toString();
	}
	
	public int getTheBowLength()
	{
		return totalWordCount;
	}
	
	public void printBOW()
	{
		for (int i = 0; i < totalWordCount; i++)
		{
			System.out.print(termID.get(bow[i][1]) + " - ");
			for (int j = 0; j < 3; j++) 
			{
				if (j==0) System.out.print("(");
				System.out.print(bow[i][j]);
				if (j==0) System.out.print(",");
				if (j==1) System.out.print(")  ");
			}
			System.out.println("");
		}
	}
	
	public int[][] getDocVec(int id)
	{
		int size[] = docVecLocator.get(id);
		if(size == null) System.err.println("invalid document id");
		int docVec[][] = new int[size[1]][2];
		//System.out.println(id + ":" + Arrays.toString(size));
		int j = 0;
		for(int i = size[0]; i < (size[0] + size[1]); i++, j++)
		{
			docVec[j][0] = bow[i][1];
			docVec[j][1] = bow[i][2];
		}
		
		return docVec;
	}
	
	public String getInfo()
	{
		StringBuffer info = new StringBuffer("text file: ");
		info.append(bowFile);
		info.append("\n");
		info.append("thesaurus file: ");
		if(thes != null)	info.append(thes.fileName());
		info.append("\n");
		
		return info.toString();
	}
	
	public String getTerms()
	{
		StringBuffer output = new StringBuffer();
		Object[] keys = termID.keySet().toArray();
		for (int i = 0; i < keys.length; i++)
			output.append(String.format("%s, %s\n",keys[i], termID.get(keys[i])));
		
		
		return output.toString();
	}
	
	public String getBowString()
	{
		StringBuffer output = new StringBuffer();
		int b[];
		
		for (Integer a : docVecLocator.keySet()) 
		{
			b = docVecLocator.get(a);
			output.append(String.format("%d:%d:%d ", a, b[0], b[1] ));
        }
		output.append("\n");
		
		for(int i = 0; i < totalWordCount; i++)
		{
			output.append(String.format("%d:%d:%d ", bow[i][0], bow[i][1], bow[i][2]));
		}
		output.append("\n");
		
		return output.toString();
	}
	
	public void loadBow(String bowString)
	{
		/****** load the docVecLocator ******/
		docVecLocator = new HashMap<Integer, int[]>();
		//take the first line of the bowString
		String bowSub[] = bowString.split("\n");
		String dvElements[] = bowSub[0].split(" ");
		
		//fill the treemap
		String a[];
		
		for(int i = 0; i < dvElements.length; i++)
		{
			int b;
			int c[] = new int[2];
			a = dvElements[i].split(":");
			//String s = ":";
			b = Integer.parseInt(a[0]);
			c[0] = Integer.parseInt(a[1]);
			c[1] = Integer.parseInt(a[2]);
			//System.out.print(b + s + c[0] + s + c[1] + " ");
			docVecLocator.put(b, c);
			//System.out.print("-" + b + s + Arrays.toString(docVecLocator.get(b)) + " ");
		}
		
		/****** load the bow ******/
		String bowElements[] = bowSub[1].split(" ");
		//check that the term counts match up
		totalWordCount = docVecLocator.get(docVecLocator.size())[0]
			+ docVecLocator.get(docVecLocator.size())[1];
//		totalWordCount = docVecLocator.get(docVecLocator.lastKey())[0]
//		                                                			+ docVecLocator.get(docVecLocator.lastKey())[1];
		int wc = bowElements.length;
		if(wc != totalWordCount)
		{
			System.err.println("the word counts do not match.");
			System.err.println(String.format("totalWordCount = %d and bow.length = %d,",
					totalWordCount, wc));					
			
		}
		
		bow = new int[totalWordCount][3];
		//int d[] = {0, 0, 0};
		for(int i = 0; i < wc; i++)
		{
			a = bowElements[i].split(":");
			bow[i][0] = Integer.valueOf(a[0]);
			bow[i][1] = Integer.valueOf(a[1]);
			bow[i][2] = Integer.valueOf(a[2]);
		}
		
	}
	
	public void loadTerms(String termString)
	{
		terms = new HashMap<String, Integer>();
		termID = new TreeMap<Integer, String>();
		//System.out.println(termString);
		String termElem[] = termString.split("\n");
		//System.out.println("the length of termElem = " + termElem.length);
		//System.out.println("the first of termElem = " + termElem[0]);
		for(int i = 0; i < termElem.length; i++)
		{
			String a[] = termElem[i].split(",");
			
			terms.put(a[1].trim(), Integer.valueOf(a[0].trim()));
			termID.put(Integer.valueOf(a[0].trim()), a[1].trim());
//			System.out.println(Integer.valueOf(a[0]) + " "
//					+ termID.get(Integer.valueOf(a[0])) + " "
//					+ a[1]);
			
		}
		// See if the term counts match
		if(uniqueWordCount != terms.size()  && uniqueWordCount != 0)
		{
			System.err.println(String.format(
					"Warning: Unique Word count and total terms loaded do not match. ")
					+ " uniqueWordCount = " + uniqueWordCount
					+ " terms.size() = " + terms.size());
		}
		
	}
}
