import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;


public class Mariana {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		// parse command line
		StringBuilder usage = new StringBuilder();
		usage.append("   Usage:\n\tjava Mariana -p 'Preprocessed Data' ");
		usage.append("-c 'Category' -o 'Model File Name'\n");
		usage.append("\n   Optional inputs:\n\t-d\ttarget number of terms\n");
		usage.append("\t-n\ttarget number of documents\n\n");
		
		CommandParse p = new CommandParse();
		HashMap<String, String> inputArg = new HashMap<String, String>();
		inputArg.put("-p", "'Preprocessed File'");
		inputArg.put("-n", "'number of documents'");
		inputArg.put("-d", "'number of terms'");
		inputArg.put("-c", "'category of interest'");
		inputArg.put("-o", "'output model file name'");
		
		ArrayList<String>  req = new ArrayList<String>();
		req.add("-p");
		req.add("-c");
		req.add("-o");
		
		p.initialize(inputArg, req, usage.toString());
		p.fill(args);
		
		Problem a = new Problem();
		a.readProblem(p.get("-p"), Integer.valueOf(p.get("-c")));
		
		int numDoc = 500, numTerm = 500;
		if(p.get("-n") != null)  numDoc = Integer.valueOf(p.get("-n")).intValue();
		if(p.get("-d") != null) numTerm = Integer.valueOf(p.get("-d")).intValue();
		
		a.buildProblem(numDoc, numTerm);
		
		String model;
		model = a.buildModel();
		
		try {
			BufferedWriter output = new BufferedWriter(new FileWriter(p.get("-o")));
			
			output.write(model);
			output.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
//		BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
		
//		try {
//			input.readLine();
//		} catch (IOException e) {
//			// TODO Auto-generated catch block
//			e.printStackTrace();
//		}
	}

}
